// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
/* $Id: OSKCompositeSampleSource.h,v 1.6.2.1 2000/09/12 18:41:24 bungi Exp $ */

#import "OSKSampleSource.h"

@class OSKSampleSource;
@class NSMutableArray, NSArray;

@protocol OSKSubsidiarySampleSource
- (OSKSampleSource *) sampleSource;
- (OSKSampleIndex) startSampleIndex;
@end


@interface OSKCompositeSampleSource : OSKSampleSource
{
    NSData *zeroData;
    NSMutableArray *subsidiarySampleSources;
    NSMutableArray *activeSampleSources;
    OSKSampleIndex nextSampleIndex;
    OSKSampleIndex nextActivitySampleSourceIndex;
    OSKSampleIndex nextActivitySampleIndex;
}

- initSamplingRate: (OSKSampleIndex) newSamplingRate
    bytesPerSample: (OSKSampleSize) newBytesPerSample
  samplesPerBuffer: (OSKSampleIndex) newSamplesPerBuffer;

- (id <OSKSubsidiarySampleSource>) addSubsidiarySampleSource: (OSKSampleSource *) sampleSource
                                            startSampleIndex: (OSKSampleIndex) startSampleIndex;

- (void) setStartSampleIndex: (OSKSampleIndex) startSampleIndex
   forSubsidiarySampleSource: (id <OSKSubsidiarySampleSource>) sampleSource;

- (void) removeSubsidiarySampleSource: (id <OSKSubsidiarySampleSource>) sampleSource;

- (NSArray *) subsidiarySampleSources;

@end
