// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
/* $Id: OSKResamplingFilter.h,v 1.1.2.1 2000/09/12 18:41:25 bungi Exp $ */

#import <OmniFoundation/OFObject.h>
#import "OSKTypes.h"

@class NSData;

typedef signed long accumulator_t;

@interface OSKResamplingFilter : OFObject
{
    /* Filter parameters */
    int filterWidth;
    int scale;
    accumulator_t *coefficients;

    /* Buffered data */
    accumulator_t *buffer;
    unsigned short _samplesPerFrame, _bytesPerSample;
    unsigned long bufferReadIndex;
    unsigned long bufferSampleCount;
}

- initWithCutoff:(double)cyclesPerSample
     filterWidth:(int)filterSize
        channels:(int)samplesPerFrame
            gain:(double)dcGain
      sampleSize:(int)bytesPerSample;

- (void)addSamples:(NSData *)samples
        decimation:(unsigned)inputDecimation;

- (void)flushWithZeroes;

- (NSData *)getSamplesOfSize:(OSKSampleSize)bytesPerSample
                  decimation:(unsigned)outputDecimation;
- (NSData *)getSamplesOfSize:(OSKSampleSize)bytesPerSample
                  decimation:(unsigned)outputDecimation
            multiplyChannels:(unsigned)times;

- (int)groupDelay;
- (unsigned char)samplesPerFrame;

@end
