// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
/* $Id: OSKResamplingStream.h,v 1.1.2.1 2000/09/12 18:41:26 bungi Exp $ */

#import "OSKSampleStream.h"
#import "OSKTypes.h"

@class OSKResamplingFilter, OSKSampleBuffer, OSKSampleStream;

@interface OSKResamplingStream : OSKSampleStream
{
    OSKResamplingFilter *filter;

    OSKSampleBuffer *nextBuffer;
    OSKSampleStream *bufferSource;

    OSKSamplingRate     _samplingRate;
    unsigned char       _numberOfChannelsIn, _numberOfChannelsOut;
    unsigned char       _bytesPerSample;
    OSKTick             groupDelayTicks;
    int                 inputDecimation;
}

- initSampleRate: (OSKSamplingRate) rate
  bytesPerSample: (int)bps
 samplesPerFrame: (int)spf
          source: (OSKSampleStream *)source
   initialBuffer: (OSKSampleBuffer *)buffer;

- (BOOL)isAtEnd;
- nextSampleBufferByInterval: (NSTimeInterval)deadline
         minimumStartingTick: (OSKTick)minimumTick;


@end
