// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
/* $Id: OSKSampleBuffer.h,v 1.6.2.1 2000/09/12 18:41:26 bungi Exp $ */

#import <OmniFoundation/OFObject.h>

#import "OSKTypes.h"

@class OFFastMutableData;

// TJW -- At some later point, this class could have methods for up/down sampling into a new sampleBuffer.  This would be useful when mixing or when playing to a sound-out device that can't easily switch sampling rates in mid-stream.

@interface OSKSampleBuffer : OFObject
{
    OSKTick             _startingTick;
    OFFastMutableData  *_sampleData;
    OSKSamplingRate     _samplingRate;
    unsigned char       _numberOfChannels;
    unsigned char       _bytesPerSample;
    unsigned int        _numberOfSamples;
}

+ (id) silentSampleBufferOfLength: (OSKSampleIndex) sampleCount
                     samplingRate: (OSKSamplingRate) samplingRate
                 numberOfChannels: (unsigned char) numberOfChannels
                   bytesPerSample: (unsigned char) bytesPerSample
                     startingTick: (OSKTick) startingTick;

- initWithSampleData: (OFFastMutableData *) sampleData
        samplingRate: (OSKSamplingRate) samplingRate
    numberOfChannels: (unsigned char) numberOfChannels
      bytesPerSample: (unsigned char) bytesPerSample
        startingTick: (OSKTick) startingTick;

- (OFFastMutableData *) sampleData;
- (OSKSamplingRate) samplingRate;
- (unsigned char) numberOfChannels;
- (unsigned char) bytesPerSample;
- (OSKTick) startingTick;

// Derived methods
- (OSKSampleIndex) numberOfSamples;
// - (NSTimeInterval) startingIntervalWithBaseTimeInterval: (NSTimeInterval) baseTimeInterval;
- (NSTimeInterval) durationSeconds;
- (OSKTick) durationTicks;
- (OSKTick) endingTick;

// Subdivision methods
- (id) subbufferStartingAtTick: (OSKTick) startingTick;

@end
