// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
/* $Id: OSKSampleSourceStream.h,v 1.1.2.1 2000/09/12 18:41:27 bungi Exp $ */

#import "OSKSampleStream.h"

#import "OSKTypes.h"

@class OSKSampleSource;

/*
 This allows an old-style OSKSampleSource to be used as a simple stream.
 */

@interface OSKSampleSourceStream : OSKSampleStream
{
    OSKSampleSource *_sampleSource;
    OSKSampleIndex   _nextSampleIndex;
    OSKSampleIndex   _lastSampleIndex;
    OSKTick          _nextTick;
    OSKSamplingRate  _samplingRate;
    unsigned char    _numberOfChannels;
    unsigned char    _bytesPerSample;
}

- initWithSampleSource: (OSKSampleSource *) sampleSource;
- (OSKSampleSource *) sampleSource;

- (OSKSampleIndex) nextSampleIndex;
- (void) setNextSampleIndex: (OSKSampleIndex) nextSampleIndex;

@end
