// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
/* $Id: OSKSampleStream.h,v 1.2.2.1 2000/09/12 18:41:27 bungi Exp $ */

#import <OmniFoundation/OFObject.h>
#import <Foundation/NSDate.h>

#import "OSKTypes.h"

@class OSKSampleBuffer;

@interface OSKSampleStream : OFObject
{
}

/*"
Attempts to return a new sample buffer by the given deadline.  If the deadline expires
before a buffer can be returned, this method returns nil.  This does not mean that
the stream is finished, but rather than it has underflowed.  Of course, if the stream
is finished, it will also return nil.
The returned buffer should have a starting tick no less than minimumStartingTick.
This is useful for recovering from streaming under/overflows.
 "*/
- (OSKSampleBuffer *) nextSampleBufferByInterval: (NSTimeInterval) deadlineInterval
                             minimumStartingTick: (OSKTick) minimumStartingTick;

/*" Returns YES if the stream has returned all the sample buffers that will ever be available. "*/
- (BOOL) isAtEnd;

@end
