// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OSKSawToothSampleSource.h"

#import <Foundation/NSData.h>
#import <OmniBase/OmniBase.h>

RCS_ID("$Id: OSKSawToothSampleSource.m,v 1.8.2.1 2000/09/12 18:41:28 bungi Exp $")

@implementation OSKSawToothSampleSource

- init;
{
    OSKSample *sampleBytes;
    unsigned int sampleIndex;
    OSKSample sampleValue, sampleStep;

    if (![super initWithFrameCount: OSK_INVALID_SAMPLE_INDEX
                      samplingRate: OSK44100SamplingRate
                          channels: 2
                    bytesPerSample: sizeof(OSKSample)
                   framesPerBuffer: NSPageSize() / (2*sizeof(OSKSample))])
        return nil;

    sampleData = [NSMutableData dataWithLength: NSPageSize()];
    sampleBytes = [(NSMutableData *)sampleData mutableBytes];

    sampleIndex = [sampleData length] / [self bytesPerFrame];
    sampleStep = sampleIndex / 256; /* make 256 waves per buffer */
    sampleValue = 0;
    while (sampleIndex--) {
        *sampleBytes++ = sampleValue; /* left */
        *sampleBytes++ = sampleValue; /* right */
        sampleValue += sampleStep;
    }

    sampleData = [[NSData alloc] initWithData: sampleData]; /* make it immutable */

    return self;
}

- (NSData *) sampleBufferStartingAtSampleIndex: (OSKSampleIndex) sampleIndex
                            beforeTimeInterval: (NSTimeInterval) beforeInterval;
{
    return sampleData;
}

@end
