// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
/* $Id: OSKSequentialFileSampleSource.h,v 1.6.2.1 2000/09/12 18:41:28 bungi Exp $ */

#import "OSKSampleSource.h"

@class OFQueue;
@class NSThread, NSLock;

@interface OSKSequentialFileSampleSource : OSKSampleSource
{
    int fd;

    OSKSampleIndex buffersPerSegment;
    OSKSampleIndex framesPerSegment;

    OSKSampleIndex segmentSize;
    OSKSampleIndex totalSize;

    OSKSampleIndex currentSegmentStartFrameIndex;
    OSKSampleIndex currentSegmentEndFrameIndex;

    NSData   *currentSegmentData;

    OFQueue  *segmentQueue;
    BOOL      segmentReaderStarted;

    NSLock   *segmentQueueLowWaterLock;
    BOOL      segmentQueueHasFilled;

    NSThread *mainThread;
}

+ (void) setDefaultBuffersPerSegment: (OSKSampleIndex) newBuffersPerSegment;
+ (void) setDefaultSegmentQueueSize: (OSKSampleIndex) newSegmentQueueSize;

- initWithFileDescriptor: (int) fileDescriptor
             sampleCount: (OSKSampleIndex) newSampleCount
            samplingRate: (OSKSamplingRate) newSamplingRate
          bytesPerSample: (OSKSampleSize) newBytesPerSample
        samplesPerBuffer: (OSKSampleIndex) newSamplesPerBuffer;

- initWithFileDescriptor: (int) fileDescriptor
              frameCount: (OSKSampleIndex) newFrameCount
            samplingRate: (OSKSamplingRate) newSamplingRate
                channels: (int) newSamplesPerFrame
          bytesPerSample: (OSKSampleSize) newBytesPerSample
         framesPerBuffer: (OSKSampleIndex) newFramesPerBuffer;

@end
