// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OSKZeroSampleSource.h"

#import <Foundation/Foundation.h>
#import <OmniBase/OmniBase.h>

RCS_ID("$Id: OSKZeroSampleSource.m,v 1.5.2.1 2000/09/12 18:41:29 bungi Exp $")

@implementation OSKZeroSampleSource

//
// 'Zero' is really the mid point of the available dyamic range of the OSKSample.
//

- init;
{
    OSKSample      *samples;
    OSKSampleIndex  sampleIndex, count;

    if (![super initWithFrameCount: OSK_INVALID_SAMPLE_INDEX
                      samplingRate: OSK44100SamplingRate
                          channels: 2
                    bytesPerSample: sizeof(OSKSample)
                   framesPerBuffer: NSPageSize() / (2*sizeof(OSKSample))])
        return nil;

    sampleData = [NSMutableData dataWithLength: NSPageSize()];
    samples = [(NSMutableData *)sampleData mutableBytes];

    count = [sampleData length] / [self bytesPerFrame];
    for (sampleIndex = 0; sampleIndex < count; sampleIndex++) {
        *samples++ = 0; // left
        *samples++ = 0; // right
    }

    samples -= 2;
#if 0  // Test left
    samples[0] = OSK_MAX_SAMPLE/4;
#endif
#if 0 // Test right
    samples[1] = OSK_MAX_SAMPLE/4;
#endif
    
    sampleData = [[NSData alloc] initWithData: sampleData]; /* make it immutable */

    NSLog(@"sampleData = %@", sampleData);
    
    return self;
}

- (NSData *) sampleBufferStartingAtSampleIndex: (OSKSampleIndex) sampleIndex
                            beforeTimeInterval: (NSTimeInterval) beforeInterval;
{
    return sampleData;
}

@end
